﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using Infragistics.Web.UI.GridControls;
using System.Data;

namespace EY.PTAS.UI.Partnerships
{
    public partial class WebForm2 : System.Web.UI.Page
    {
        long scenarioID = 0;

        public Hashtable ValTable
        {
            get
            {
                Hashtable tt = new Hashtable();

                if (Session["Store1"] != null)
                    tt = Session["Store1"] as Hashtable;

                return tt;
            }
            set
            {
                Session["Store1"] = value;
            }
        }


        public Hashtable dd = new Hashtable();

        #region "Page level events"
        /// <summary>
        /// Page Load event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void Page_Load(object sender, EventArgs e)
        {
            if (Session["ScenarioID"] != null)
                scenarioID = Convert.ToInt64(Session["ScenarioID"]);

            if (!Page.IsPostBack)
            {

                dd.Add(1, "Test1");
                dd.Add(2, "Test2");
            }

            BindGrid();
        }


        private void BindGrid()
        {
            //DataTable dt = new DataTable();

            //dt.Columns.Add("Partner Name");
            //dt.PrimaryKey = new DataColumn[] { dt.Columns["Partner Name"] };

            //dt.Columns.Add("PartnerId", typeof(long));
            //dt.Columns.Add("Labl1", typeof(string));
            //dt.Columns.Add("Labl2", typeof(DateTime));

            //DataRow dr;
            //dr = dt.NewRow();

            //Hashtable tt = new Hashtable();

            //tt[2] = "DropDown&&1";
            //tt[3] = "TextBox&&2";

            //ValTable = tt;

            //dr[0] = "Partner1";
            //dr[1] = 101;
            //dr[2] = "11";
            //dr[3] = DateTime.Now;

            //dt.Rows.Add(dr);

            //dr = dt.NewRow();
            //dr[0] = "Partner2";
            //dr[1] = 202;
            //dr[2] = "21";
            //dr[3] = DateTime.Now.AddDays(-10);

            //dt.Rows.Add(dr);

            //List<string> str = new List<string>();
            //str.Add("a");
            //str.Add("b");

            ////this.wdgPartnerAttributes.Behaviors.CreateBehavior<EditingCore>();
            ////this.wdgPartnerAttributes.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();
          
            //Session["dataSource"] =  dt;
            //Session["str"] = str;

            wdgPartnerAttributes.Rows.Clear();
            wdgPartnerAttributes.ClearDataSource();
            wdgPartnerAttributes.DataSource = Session["dataSource"];
            wdgPartnerAttributes.DataBind();
        }


        private void PutDataSourceInSession() 
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("Partner Name");
            dt.PrimaryKey = new DataColumn[] { dt.Columns["Partner Name"] };

            dt.Columns.Add("PartnerId", typeof(long));
            dt.Columns.Add("Labl1", typeof(string));
            dt.Columns.Add("Labl2", typeof(DateTime));

            DataRow dr;
            dr = dt.NewRow();

            Hashtable tt = new Hashtable();

            tt[2] = "DropDown&&1";
            tt[3] = "TextBox&&2";

            ValTable = tt;

            dr[0] = "Partner1";
            dr[1] = 101;
            dr[2] = "11";
            dr[3] = DateTime.Now;

            dt.Rows.Add(dr);

            dr = dt.NewRow();
            dr[0] = "Partner2";
            dr[1] = 202;
            dr[2] = "21";
            dr[3] = DateTime.Now.AddDays(-10);

            dt.Rows.Add(dr);

            List<string> str = new List<string>();
            str.Add("a");
            str.Add("b");

            //this.wdgPartnerAttributes.Behaviors.CreateBehavior<EditingCore>();
            //this.wdgPartnerAttributes.Behaviors.EditingCore.Behaviors.CreateBehavior<CellEditing>();

            Session["dataSource"] = dt;
            Session["str"] = str;
        }

        private void CreateProviders(DataTable dt, List<string> str) 
        {

            //if (IsPostBack)
            //{
                for (int cnt = 2; cnt < dt.Columns.Count; cnt++)
                {
                    string[] arrvalue = ValTable[cnt].ToString().Split("&&".ToCharArray());

                    string datatype = arrvalue[0];

                    if (datatype == "DropDown")
                    {

                        DropDownProvider ddlProvider = new DropDownProvider();
                        ddlProvider.EditorControl.DataSource = str;


                        ddlProvider.ID = "ddlProvider" + cnt;
                        this.wdgPartnerAttributes.EditorProviders.Add(ddlProvider);

                        EditingColumnSetting columnSetting = new EditingColumnSetting();
                        columnSetting.ColumnKey = dt.Columns[cnt].ColumnName;
                        columnSetting.EditorID = ddlProvider.ID;

                        this.wdgPartnerAttributes.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(columnSetting);

                    }
                    else
                    {
                        DatePickerProvider date1 = new DatePickerProvider();
                        date1.ID = "date" + cnt;
                        this.wdgPartnerAttributes.EditorProviders.Add(date1);

                        EditingColumnSetting columnSetting1 = new EditingColumnSetting();
                        columnSetting1.ColumnKey = dt.Columns[cnt].ColumnName;
                        columnSetting1.EditorID = date1.ID;

                        this.wdgPartnerAttributes.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(columnSetting1);
                    }
                } 
            //}        
        }

        protected override void OnInit(EventArgs e)
        {
            wdgPartnerAttributes.InitializeRow += new InitializeRowEventHandler(wdgPartnerAttributes_InitializeRow);            
            base.OnInit(e);
        }

        # endregion

        #region "User Defined Function"

        protected void wdgPartnerAttributes_Init(object sender, EventArgs e)
        {
            PutDataSourceInSession();
            CreateProviders(Session["dataSource"] as DataTable, Session["str"] as List<string>);
        }

        protected void wdgPartnerAttributes_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            DataRowView dv = e.Row.DataItem as DataRowView;

            e.Row.Items[1].Column.Hidden = true;
        }


        /// <summary>
        /// Save button click event
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSave_Click(object sender, EventArgs e)
        {
            Response.Write("Button click");
        }


        #endregion
    }
}